#include <stdio.h>
#include <pcap.h>
#include "conf.h"
#include "miscutil.h"
#include "db.h"
#include "config.h"

MYSQL *conn;
struct database dbase;
config cfg;
char cfgpath[128];
char errbuf[CONFERRBUFSIZ];
extern char pathdb[128];
void db_initialize()
{
	
	
		
	strcpy(cfgpath, pathdb);
	if ((config_load(&cfg, cfgpath, errbuf)) == NULL) {
		fprintf(stderr, "init_config: %s\n", errbuf);
		exit(1);
	}
	get_initcfgvals();
	conn = mysql_init(NULL);
	
	if(mysql_real_connect(conn, dbase.server, dbase.user, dbase.password, dbase.database, 0, NULL, 0) == NULL){
		mysql_close(conn);
		
		fprintf(stderr, "%s\n", mysql_error(conn));
		exit(0);
	}
	
	
		
} 

void add_message(struct msn_message *message)
{
	int id, sizelen, a, b, length;
	char sqlquery[7000]={'\0'};
	char *messagebuffer;
	
	sizelen = strlen(message->message);
	b = 0;

	if(strchr(message->message, '\'') != NULL){
		messagebuffer = (char*) malloc(sizeof(char)*6650);
		for(a = 0; a < sizelen; a++){
			if(message->message[a] != '\'')
				messagebuffer[b] = message->message[a];
			else{
				messagebuffer[b] = '\\';
				b++;
				messagebuffer[b] = '\'';
			}
			b++;
		}	

		messagebuffer[b] = '\0';
		length = snprintf(sqlquery,sizeof(sqlquery) - 1,"INSERT INTO tmessage (local, remote, message, direct, lip,times) VALUES('%s', '%s', '%s','%s','%s', CURRENT_TIMESTAMP())", message->local, message->remote, messagebuffer,message->direction, message->local_ip);
		free(messagebuffer);
	}else
		length = snprintf(sqlquery,sizeof(sqlquery) - 1,"INSERT INTO tmessage (local, remote, message, direct, lip,times) VALUES('%s', '%s', '%s','%s','%s', CURRENT_TIMESTAMP())", message->local, message->remote, message->message,message->direction, message->local_ip);
	if(length < 0){
		mysql_close(conn);
		exit(0);
	}
	sqlquery[length] = '\0';
	set_mysql_query(sqlquery);
}
void set_mysql_query( char *query)
{
	if (mysql_query(conn, query)) 
        	
        	mysql_ping(conn);
		
         
}
void get_initcfgvals()
{
	if (config_getstr(&cfg, "GENERAL", "server", dbase.server, sizeof(dbase.server) -2) == 0) {
		printf("cannot get mgmtipcpath from configfile, shutting down......\n");
		exit(1);
	}
	
	if (config_getstr(&cfg, "GENERAL", "dbname", dbase.database, sizeof(dbase.database) -2) == 0) {
		printf("cannot get mgmtipcpath from configfile, shutting down......\n");
		exit(1);
	}

	if (config_getstr(&cfg, "GENERAL", "user", dbase.user, sizeof(dbase.user) -2) == 0) {
		printf("cannot get mgmtipcpath from configfile, shutting down......\n");
		exit(1);
	}

	if (config_getstr(&cfg, "GENERAL", "password", dbase.password, sizeof(dbase.password) -2) == 0) {
		printf("cannot get mgmtipcpath from configfile, shutting down......\n");
		exit(1);
	}



}
