#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pcap.h>
#include <iconv.h>
#include <time.h>
#include "msn.h"
#include "defs.h"


int NumberOfAccount = 0;	/*dizi tutulabilecek toplam account says*/
struct account_ip *accounts[MEMORYSIZE] = {NULL};
void resolv_msn( int size_ip, struct account_ip *users, int datalink, char *tmessage, int data_length)
{	
	struct msn_message message = {'\0', '\0', '\0', 0};
	char  *data, *konum, *length, *end, *getstr, len[5]={'\0'}, ifstr[30]={'\0'}, sqlquery[50]={'\0'}, *dates;
	struct  account_ip *control;
	int a = 0, b = 0, ilen,inlen,outlen, i, id,fark;
	uint32_t ipaddr;
	in_addr_t net_ip;
	uint16_t ids;
	char *out, *mesaj;
	iconv_t cd;
	struct in_addr in;
	long timer;
	data = tmessage;

	if( strncmp(data, "MSG",3) == 0){
		if((konum = (char*)nstrstr(data, "Content-Type: text/plain", data_length)) != NULL){
			if((konum = nstrstr(data, "\r\n\r\n", data_length)) == NULL)
				return;
			length = strchr(data, '\r');	
			end = length;

			if(users->srcport == MSN_PORT){
				getstring(data + 4, users->account, ' ');
				if( (control = (struct account_ip*)lineer_search(users, 1)) == NULL )
					hashing(users);
				strncpy(message.remote, users->account, sizeof(users->account));
				message.remote[sizeof(users->account ) - 1] = '\0';
				exchange(users);
				if( (control =(struct account_ip*)lineer_search(users, 1)) == NULL ){
					strncpy(message.local, "unknown", strlen("unknown"));
					message.local[strlen("unknown")] = '\0';
				}else{
					strncpy(message.local, control->account, sizeof(control->account));
					message.local[sizeof(control->account) - 1] = '\0';

				}
				strncpy(message.direction, "in", 2);
				message.direction[2] = '\0';

				in.s_addr = htonl(users->srcip);
				if(strlen(inet_ntoa(in)) >= sizeof(message.local_ip))
					ilen = sizeof(message.local_ip) - 1;
				else
					ilen = strlen(inet_ntoa(in));

				strncpy(message.local_ip,inet_ntoa(in), ilen);
				message.local_ip[ilen] = '\0';
			}else{
				if( (control =(struct account_ip*)lineer_search(users, 1)) == NULL ){
					strncpy(message.local, "unknown", strlen("unknown"));
					message.local[strlen("unknown")] = '\0';
				}else{
					strncpy(message.local, control->account, sizeof(control->account));
					message.local[sizeof(control->account) - 1] = '\0';
				}
				exchange(users);

				if( (control =(struct account_ip*)lineer_search(users, 1)) == NULL ){
					strncpy(message.remote, "unknown", strlen("unknown"));
					message.remote[strlen("unknown")] = '\0';
				}else{
					strncpy(message.remote, control->account, sizeof(control->account));
					message.remote[sizeof(control->account) - 1] = '\0';   
				}	
				strncpy(message.direction, "out", 3);
				message.direction[3] = '\0';
				in.s_addr = htonl(users->dstip);

				if(strlen(inet_ntoa(in)) >= sizeof(message.local_ip))
					ilen = sizeof(message.local_ip) - 1;
				else
					ilen = strlen(inet_ntoa(in));

				strncpy(message.local_ip,inet_ntoa(in), ilen);
				message.local_ip[ilen] = '\0';
			}

			while (*(length - 1) != ' ')  /*mesajn uzunluu alnr*/
				--length;
			a=0; b= 0;

			end = data;
			end = end + data_length;
			
			konum = konum + 4;
			a = 0;
			while (konum != end && a < 3299){
				message.message[a] = (char)*konum;
				a++; konum++;
			}	
			message.message[a] = '\0';
			inlen = a;
			out = (char*)malloc(3300);
			outlen = 3300;
			memset(out, '\0',3300);
			if((cd = iconv_open("ISO-8859-9", "UTF-8")) ==(iconv_t) -1){
				perror("iconv error ");
				exit(1);
			}

			mesaj = message.message;
			iconv(cd, (const char* *)&mesaj, (size_t*)&inlen , (char* *)&out, (size_t*)&outlen);
			out -=(3300 - outlen);
			if (strlen(out) < 3300)
				ilen = strlen(out);
			else{
				ilen = 3299;

			}
			strncpy(message.message, out, ilen);
			message.message[ilen] = '\0'; 	

			free(out);

			#ifdef _mysql_

			add_message(&message);
			#else
			timer = time(NULL);
			if(strncmp(message.direction, "out", 3) == 0){
				printf("-----------------------\n");
				printf("\n%s\nLocal ip: %s\nfrom: %s\nTo: %s\n%s\n",ctime((time_t*)&timer),message.local_ip,message.local, message.remote, message.message);
			}else {
				printf("-----------------------\n");
				printf(" \n%s\nlocal ip: %s\nFrom: %s\nTo: %s\n%s\n",ctime((time_t*)&timer), message.local_ip,message.remote, message.local,  message.message);
			}
			#endif

		}else if((konum =(char*)nstrstr(data, "TypingUser", data_length)) != NULL)
			if(lineer_search(users, 1) == NULL ){

				konum = strchr(konum , ' ');
				getstring(konum + 1, users->account, '\r');
				hashing(users);
			}

	}else if( strncmp(data, "JOI", 3) == 0){
		if( lineer_search(users, 1) == NULL ){
			konum = strchr(data, ' ');
			getstring(konum + 1, users->account, ' ');
			hashing(users);
		}
		
	}else if(strncmp(data, "ANS", 3) == 0 && (strstr(data ,"OK") == NULL) ){
		
		if( lineer_search(users, 1) == NULL ){
			konum = strchr(data + 4, ' ');
			end = strchr(konum + 1 , ' ');
			if(end != NULL){
				getstring(konum + 1, users->account, ' ');
				hashing(users);
			}
		}
	}
	else if( strncmp(data, "BYE", 3) == 0){
		
		
		lineer_search(users, 2);
	
		exchange(users);
		lineer_search(users, 2);
			
		
	}else if(strncmp(data,"IRO",3) == 0){
		
		if( lineer_search(users, 1) == NULL ){
			konum = data;
			for(a = 0; a < 4; a++)
				konum = strchr(konum + 1,' ');
			getstring(konum + 1, users->account, ' ');
			hashing(users);
		}
	}else if(strncmp(data,"OUT",3) == 0){
		
		lineer_search(users, 2);
		exchange(users);
		lineer_search(users, 2);
	}
	else if(strncmp(data, "USR", 3) == 0){
		
		if( lineer_search(users, 1) == NULL ){
			if( (konum = strstr(data ,"OK")) != NULL ){
				a = 0;b = 0;
				while(data[b] != '\r'){
					if(data[b] == ' ')  a++;
					b++;
				}
				if(a == 4){
					exchange(users);
					getstring(konum + 3, users->account, ' ');
					hashing(users);
				}
			
			}
		}
	}
		
}

void getstring(const char *const data,char *account,char karak)
{
	int ilen;
	char *getstr ;
	getstr = strchr(data , karak);
	ilen = (int)(getstr -data);
	Strncpy(account, data, ilen);
	
}
void Strncpy(char *str1,const char *const str2, int length)
{
	int a = 0;
	while(a < length && a < 127){
		str1[a] = (char) *(str2+a);
		a++;
	}
	str1[a] = '\0';
}

uint32_t convert_ip(struct  in_addr *ip)
{
	in_addr_t net_ip;
	uint32_t ipaddr;
	
	net_ip = inet_addr(inet_ntoa(*ip));
	ipaddr = ntohl(net_ip);

	return ipaddr;
}

void packet_resolv(u_char *datalink, const struct pcap_pkthdr *pkthdr, const u_char *packet)
{
	struct ethernet_header *ethernet;
	struct ip *ip;
	struct tcphdr *tcp;
	int size_ip, size_tcp, total_length, ilen;
	static int data_length = 0; 
	static int kontrol = 0;
	static char message[3600] = {'\0'};
	static struct account_ip users;
	char *data;
	
	ethernet = (struct ethernet_header*) packet;
	ip = (struct ip*)(packet + (int)*datalink);
	size_ip = ip->ip_hl * 4;
	if(size_ip < 20)
		return;
	

	if(ip->ip_p == IPPROTO_TCP){
		tcp = (struct tcphdr*)(packet + (int)*datalink + size_ip);
		size_tcp = tcp->th_off * 4;
		if (size_tcp < 20)
			return;
		total_length = size_ip + size_tcp;
		if(ntohs(ip->ip_len) > total_length){
			if(ntohs(tcp->th_sport) == MSN_PORT || ntohs(tcp->th_dport) == 	MSN_PORT ){
				users.srcip = convert_ip(&ip->ip_src);
				users.dstip = convert_ip(&ip->ip_dst);
				users.srcport = ntohs(tcp->th_sport);
				users.dstport = ntohs(tcp->th_dport);
				data = (char*)(packet + (int)*datalink + size_ip + tcp->th_off*4);
				
				if(tcp->th_flags & TH_PUSH ){
					ilen = (ntohs(ip->ip_len) - total_length);
					data_length += ilen;
					if(data_length >= sizeof(message)){
						ilen = sizeof(message)- (data_length - ilen - 1);	
						data_length = sizeof(message) - 1;
					}
					strncat(message, data, ilen);
					message[data_length] = '\0';
					resolv_msn(size_ip, &users ,(int)*datalink, message, data_length);
					message[0] = '\0';
					data_length = 0;
				}else{
					strncat(message, data, ntohs(ip->ip_len) - total_length);
					data_length += (ntohs(ip->ip_len) - total_length);
					if(data_length >= sizeof(message))
						data_length = sizeof(message) - 1;
					message[data_length] = '\0';
									
				}
				
			}	
			
		}
	}
	

		
}
void exchange(struct account_ip *user)
{
	uint32_t ip;
	uint16_t port;

	ip = user->dstip;
	user->dstip = user->srcip;
	user->srcip = ip;

	port = user->dstport;
	user->dstport = user->srcport;
	user->srcport = port;
}
