#define __USE_BSD 1
#define __FAVOR_BSD 1

#include <pcap.h>

#include <stdio.h>
#include <stdlib.h>

#include "msn.h"
#include "sniff.h"


extern pcap_t *handle;
extern pcap_if_t *alldev;

void sniffing()
{
	
	char errbuf[PCAP_ERRBUF_SIZE];
	bpf_u_int32 mask, net;
	int a,datalink, *datalinksize;

	if(pcap_lookupnet(alldev->name, &net, &mask, errbuf) == -1){
		fprintf(stderr, "Couldn't get netmask for device %s:%s\n", alldev->name, errbuf );
		net = 0;
		mask = 0;
		exit(EXIT_FAILURE);
	}

	
	datalinksize = &datalink;
	datalink = pcap_datalink(handle);
	if(datalink == DLT_EN10MB)
		*datalinksize =  14;
	else if(datalink == DLT_PPP)
		*datalinksize == 4;
	else if(datalink == DLT_RAW)
		*datalinksize = 0;
	
	else{
		fprintf(stderr,"Interface type is unknown");
		exit(1);
	}
	if( (a = pcap_loop(handle, -1, packet_resolv, (u_char*)datalinksize)) == -1){
		fprintf(stderr, "pcap_loop: %s", pcap_geterr(handle));
		exit(1);
	}
}
